## cairo-dock 3.0.99.beta1.1~20120827~bzr1193

=== CMakeLists.txt ===
########### requirements ###############

cmake_minimum_required (VERSION 2.6)
find_package (PkgConfig)
include (CheckLibraryExists)
include (CheckIncludeFiles)
include (CheckFunctionExists)
include (CheckSymbolExists)
include ("${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/GNUInstallDirs.cmake")

########### project ###############

project ("cairo-dock")
set (VERSION "3.0.99.beta1")

add_definitions (-std=c99 -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes) # removed for stable versions: -Wstrict-prototypes #-Wunreachable-code -Wno-unused-parameter -Wall 
if (NOT ${CMAKE_BUILD_TYPE})
	add_definitions (-O3)
endif()
add_definitions (-DGL_GLEXT_PROTOTYPES="1")
add_definitions (-DCAIRO_DOCK_DEFAULT_ICON_NAME="default-icon.svg")
add_definitions (-DCAIRO_DOCK_ICON="cairo-dock.svg")
add_definitions (-DCAIRO_DOCK_LOGO="cairo-dock-logo.png")
add_definitions (-DCAIRO_DOCK_DATA_DIR="cairo-dock")
if (NOT "${force-icon-in-menus}" STREQUAL "no")  # we believe that not showing icons in the menus by default is a terrible idea; unfortunately, it's not easily undoable for an end-user; so until this is fixed by a big player (Gnome, Ubuntu or other), we'll force the display, unless "-Dforce-icon-in-menus=yes" is provided in the cmake command.
	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=1)
else()
	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=0)
endif()
add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

############ sources tarball ############

set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${VERSION}")
set (CPACK_SOURCE_IGNORE_FILES 
	"/build/;/.bzr/;bzrignore$;/config.h$;/gldi-config.h$;/doc/;/misc/;~$;/TODO$;${CPACK_SOURCE_IGNORE_FILES}")
include (CPack)

add_custom_target( dist
	COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
add_custom_target(dist-bzr
	COMMAND bzr export ${CMAKE_PROJECT_NAME}-${VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

########### global variables ###############

if( WIN32 )
	message(FATAL_ERROR "Cairo-Dock requires an air-conditioned room. Please close Windows!")
endif( WIN32 )

set (PACKAGE ${CMAKE_PROJECT_NAME})
set (GETTEXT_PACKAGE ${PACKAGE})

set (prefix ${CMAKE_INSTALL_PREFIX})  # /usr/local
set (exec_prefix ${prefix})
set (datadir "${prefix}/${CMAKE_INSTALL_DATAROOTDIR}")  # (...)/share
set (pkgdatadir "${datadir}/${CMAKE_PROJECT_NAME}")  # (...)/cairo-dock
set (mandir "${prefix}/${CMAKE_INSTALL_MANDIR}")  # (...)/man

set (VERSION_HELP "0.9.992") # needed to parse Help.conf.in

if( CMAKE_SIZEOF_VOID_P EQUAL 8 AND "${FORCE_LIB64}" STREQUAL "yes")  # 64bits and force install in lib64
	set (libdir "${prefix}/lib64")
else()
	set (libdir "${prefix}/${CMAKE_INSTALL_LIBDIR}${LIB_SUFFIX}")  # (...)/lib
endif()

set (includedir "${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")  # (...)/include
set (bindir "${prefix}/${CMAKE_INSTALL_BINDIR}")  # (...)/bin

########### dependencies ###############

set (packages_required "glib-2.0 gthread-2.0 cairo librsvg-2.0 dbus-1 dbus-glib-1 libxml-2.0 xrender gl glu pangox libcurl")  # for the .pc and to have details
STRING (REGEX REPLACE " " ";" packages_required_semicolon ${packages_required})  # replace blank space by semicolon => to have more details if a package is missing
pkg_check_modules ("PACKAGE" REQUIRED "${packages_required_semicolon}")

set (xextend_required "xtst xcomposite xinerama xrandr")  # for the .pc
STRING (REGEX REPLACE " " ";" xextend_required_semicolon ${xextend_required})
pkg_check_modules ("XEXTEND" "${xextend_required_semicolon}")

if (${XEXTEND_FOUND})
	set (HAVE_XEXTEND 1)
else()
	set (xextend_required)
endif()

if (NOT "${force-gtk2}" STREQUAL "yes")  # by default, we use GTK+3 except if we force the use of GTK+2
	set (gtk_required "gtk+-3.0")  # for the .pc
	pkg_check_modules ("GTK" "${gtk_required}")  # the check is not set as 'required' because we can use GTK+2 if GTK+3 isn't available
endif()

if (NOT "${GTK_FOUND}")
	set (gtk_required "gtk+-2.0")  # for the .pc
	pkg_check_modules ("GTK" REQUIRED "${gtk_required}")  # the check is requiered this time because we need GTK anyway.
endif()

STRING (REGEX REPLACE "\\..*" "" GTK_MAJOR "${GTK_VERSION}")

add_definitions (-DGTK_DISABLE_DEPRECATED="1")
# add_definitions (-DG_DISABLE_DEPRECATED="1")

# We use crypt(3) which may be in libc, or in libcrypt (eg FreeBSD)
check_library_exists (crypt encrypt "" HAVE_LIBCRYPT)
if (${HAVE_LIBCRYPT})
	set (LIBCRYPT_LIBS "-lcrypt")
endif()

check_symbol_exists (LC_MESSAGES "locale.h" HAVE_LC_MESSAGES)
check_include_files ("math.h" HAVE_MATH_H)
check_library_exists (m sin "" HAVE_LIBM)
if (NOT ${HAVE_LIBM} OR NOT ${HAVE_MATH_H})
	message(FATAL_ERROR "Cairo-Dock requires math.h")
endif()

check_include_files ("dlfcn.h" HAVE_DLFCN_H)
check_library_exists (dl dlopen "" HAVE_LIBDL)
if (NOT ${HAVE_LIBDL} OR NOT ${HAVE_DLFCN_H})
	message(FATAL_ERROR "Cairo-Dock requires dlfcn.h")
endif()

MESSAGE (STATUS)
MESSAGE (STATUS "Cairo-Dock will be compiled with the following options :")
if (${XEXTEND_FOUND})
	MESSAGE (STATUS " * Use X Extensions : yes")
else()
	MESSAGE (STATUS " * Use X Extensions : no")
endif()
if (${HAVE_LIBCRYPT})
	MESSAGE (STATUS " * crypt passwords : yes")
else()
	MESSAGE (STATUS " * crypt passwords : no")
endif()
MESSAGE (STATUS " * GTK version : ${GTK_MAJOR}")
MESSAGE (STATUS)

########### variables defined at compil time ###############

set (CAIRO_DOCK_SHARE_DATA_DIR ${pkgdatadir})
set (CAIRO_DOCK_SHARE_THEMES_DIR ${pkgdatadir}/themes)
#set (CAIRO_DOCK_MODULES_DIR ${libdir}/cairo-dock)
set (CAIRO_DOCK_LOCALE_DIR "${prefix}/${CMAKE_INSTALL_LOCALEDIR}")
set (CAIRO_DOCK_THEMES_DIR "themes")  # folder name where themes are saved locally, relatively to the root folder of Cairo-Dock.
set (CAIRO_DOCK_DISTANT_THEMES_DIR "themes3.1")  # folder name where themes are on the server, relatively to the root folder of the server files.
set (CAIRO_DOCK_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})

set (GLDI_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})
set (GLDI_SHARE_DATA_DIR ${pkgdatadir})
set (GLDI_MODULES_DIR ${libdir}/cairo-dock)
set (GLDI_BIN_DIR ${bindir})

########### next steps ###############

add_subdirectory (src)
add_subdirectory (data)
add_subdirectory (po)

########### file generation ###############

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake.in ${CMAKE_CURRENT_SOURCE_DIR}/src/config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/gldit/gldi-config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock.pc.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)

########### install files ###############

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.pc DESTINATION ${libdir}/pkgconfig)

###########     misc      ###############
#set (CPACK_SOURCE_GENERATOR "TGZ")
#set (CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${VERSION}")
#set (CPACK_SOURCE_IGNORE_FILES "/build/;/.bzr/;/.deps/;Makefile$;Makefile.in;.gmo$;/.libs/;.lo$;.la$;POTFILES;stamp-it;aclocal.m4;config.guess$;/config.h$;/config.h.in$;/config.log$;/config.status$;/config.sub$;/configure$;/depcomp$;/install-sh$;/libtool$;/ltmain.sh$;/missing$;/stamp-h1$;/compile;/CMakeFiles/;/_CPack_Packages/;/autom4te.cache/;/install_manifest.txt$;.tar.gz$;/CMakeCache.txt$;/cairo-dock$;/scripts/;/doc/;/data/themes.conf$;/data/cairo-dock.conf$;/data/main-dock.conf$;/data/cairo-dock-simple.conf$;/cairo-dock.pc$;.cmake$;~$;${CPACK_SOURCE_IGNORE_FILES}")
#include (CPack)  # a inclure apres les set.
#add_custom_target( dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)  # pour pouvoir l'appeler avec "make dist"

=== data/CMakeLists.txt ===
add_subdirectory(themes)
add_subdirectory(gauges)
add_subdirectory(explosion)
add_subdirectory(man)
add_subdirectory(icons)
add_subdirectory(images)
add_subdirectory(scripts)
if ("${enable-desktop-manager}" STREQUAL "yes")
	add_subdirectory(desktop-manager)
endif()


########### file generation ###############

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock.conf.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.conf)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock-simple.conf.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock-simple.conf)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/main-dock.conf.in ${CMAKE_CURRENT_BINARY_DIR}/main-dock.conf)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/launcher.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/launcher.desktop)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/container.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/container.desktop)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/separator.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/separator.desktop)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/themes.conf.in ${CMAKE_CURRENT_BINARY_DIR}/themes.conf)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Help.conf.in ${CMAKE_CURRENT_BINARY_DIR}/Help.conf)


########### install files ###############

# misc
install (FILES
	cairo-dock.svg
	readme-default-view
	ChangeLog.txt
	DESTINATION ${pkgdatadir})

# appli icon
install (FILES
	cairo-dock.svg
	DESTINATION ${datadir}/pixmaps)

# conf files
install (FILES
	# lib
	${CMAKE_CURRENT_BINARY_DIR}/main-dock.conf
	${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.conf
	${CMAKE_CURRENT_BINARY_DIR}/launcher.desktop
	${CMAKE_CURRENT_BINARY_DIR}/container.desktop
	${CMAKE_CURRENT_BINARY_DIR}/separator.desktop
	# appli
	${CMAKE_CURRENT_BINARY_DIR}/cairo-dock-simple.conf
	${CMAKE_CURRENT_BINARY_DIR}/themes.conf
	${CMAKE_CURRENT_BINARY_DIR}/Help.conf
	DESTINATION ${pkgdatadir})

# appli desktop file
install (FILES
	cairo-dock.desktop
	cairo-dock-cairo.desktop
	DESTINATION ${datadir}/applications)

=== src/CMakeLists.txt ===

add_subdirectory (icon-factory)
add_subdirectory (gldit)
add_subdirectory (implementations)
add_subdirectory (help)

SET(cairo_dock_SRCS
	cairo-dock.c
	cairo-dock-menu.c 					cairo-dock-menu.h 
	cairo-dock-user-interaction.c 		cairo-dock-user-interaction.h 
	cairo-dock-gui-main.c 				cairo-dock-gui-main.h
	cairo-dock-gui-simple.c 			cairo-dock-gui-simple.h
	cairo-dock-gui-backend.c 			cairo-dock-gui-backend.h
	cairo-dock-gui-commons.c 			cairo-dock-gui-commons.h
	cairo-dock-widget.c 				cairo-dock-widget.h
	cairo-dock-widget-themes.c 			cairo-dock-widget-themes.h
	cairo-dock-widget-items.c 			cairo-dock-widget-items.h
	cairo-dock-widget-config.c 			cairo-dock-widget-config.h
	cairo-dock-widget-plugins.c 		cairo-dock-widget-plugins.h
	cairo-dock-widget-module.c			cairo-dock-widget-module.h
	cairo-dock-widget-config-group.c 	cairo-dock-widget-config-group.h
	cairo-dock-widget-shortkeys.c		cairo-dock-widget-shortkeys.h
)

########### compilation ###############

# Make sure the compiler can find include files from the libraries.
include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${XEXTEND_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

# Make sure the linker can find the libraries.
link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS}
	${XEXTEND_LIBRARY_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/help)

# Add executable that is built from the source files.
add_executable (${PROJECT_NAME}
	${cairo_dock_SRCS} )

# Link the executable to the librairies.
target_link_libraries (${PROJECT_NAME}
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES}
	${XEXTEND_LIBRARIES}
	${LIBCRYPT_LIBS}
	gldi
	icon-factory
	implementations
	help)

# install the program once it is built.
install(
	TARGETS ${PACKAGE}
	DESTINATION bin)

=== src/gldit/CMakeLists.txt ===

SET(core_lib_SRCS
	cairo-dock-struct.h
	cairo-dock-global-variables.h 
	cairo-dock-core.c 					cairo-dock-core.h
	cairo-dock-manager.c 				cairo-dock-manager.h
	cairo-dock-object.c 				cairo-dock-object.h
	# icons
	cairo-dock-icon-manager.c 			cairo-dock-icon-manager.h
	cairo-dock-icon-factory.c 			cairo-dock-icon-factory.h
	cairo-dock-icon-facility.c 			cairo-dock-icon-facility.h
	cairo-dock-indicator-manager.c 		cairo-dock-indicator-manager.h
	cairo-dock-applications-manager.c 	cairo-dock-applications-manager.h 
	cairo-dock-application-facility.c 	cairo-dock-application-facility.h
	cairo-dock-launcher-manager.c 		cairo-dock-launcher-manager.h
	cairo-dock-applet-manager.c 		cairo-dock-applet-manager.h
	cairo-dock-applet-facility.c 		cairo-dock-applet-facility.h
	cairo-dock-separator-manager.c 		cairo-dock-separator-manager.h
	cairo-dock-module-factory.c 		cairo-dock-module-factory.h
	cairo-dock-module-manager.c 		cairo-dock-module-manager.h
	# containers
	cairo-dock-container.c 				cairo-dock-container.h
	cairo-dock-desklet-manager.c 		cairo-dock-desklet-manager.h
	cairo-dock-desklet-factory.c 		cairo-dock-desklet-factory.h
	cairo-dock-dialog-factory.c 		cairo-dock-dialog-factory.h
	cairo-dock-dialog-manager.c 		cairo-dock-dialog-manager.h
	cairo-dock-flying-container.c 		cairo-dock-flying-container.h
	cairo-dock-dock-manager.c 			cairo-dock-dock-manager.h
	cairo-dock-dock-factory.c 			cairo-dock-dock-factory.h
	cairo-dock-dock-facility.c 			cairo-dock-dock-facility.h
	cairo-dock-callbacks.c 				cairo-dock-callbacks.h 
	cairo-dock-animations.c 			cairo-dock-animations.h
	cairo-dock-notifications.c 			cairo-dock-notifications.h
	cairo-dock-backends-manager.c 		cairo-dock-backends-manager.h
	cairo-dock-data-renderer.c 			cairo-dock-data-renderer.h
	cairo-dock-data-renderer-manager.c 		cairo-dock-data-renderer-manager.h
	cairo-dock-file-manager.c 			cairo-dock-file-manager.h
	cairo-dock-themes-manager.c 		cairo-dock-themes-manager.h
	cairo-dock-class-manager.c 			cairo-dock-class-manager.h
	cairo-dock-X-manager.c 				cairo-dock-X-manager.h
	cairo-dock-image-buffer.c			cairo-dock-image-buffer.h 
	cairo-dock-opengl.c 				cairo-dock-opengl.h
	cairo-dock-opengl-path.c 			cairo-dock-opengl-path.h
	cairo-dock-opengl-font.c 			cairo-dock-opengl-font.h
	cairo-dock-surface-factory.c 		cairo-dock-surface-factory.h
	cairo-dock-draw.c 					cairo-dock-draw.h 
	cairo-dock-draw-opengl.c 			cairo-dock-draw-opengl.h
	# utilities
	cairo-dock-log.c 					cairo-dock-log.h
	cairo-dock-gui-manager.c 			cairo-dock-gui-manager.h
	cairo-dock-gui-factory.c 			cairo-dock-gui-factory.h
	eggaccelerators.c 					eggaccelerators.h
	cairo-dock-keybinder.c 				cairo-dock-keybinder.h
	cairo-dock-dbus.c 					cairo-dock-dbus.h 
	cairo-dock-X-utilities.c 			cairo-dock-X-utilities.h
	cairo-dock-keyfile-utilities.c 		cairo-dock-keyfile-utilities.h
	cairo-dock-packages.c 				cairo-dock-packages.h
	cairo-dock-particle-system.c 		cairo-dock-particle-system.h
	cairo-dock-overlay.c 				cairo-dock-overlay.h
	cairo-dock-task.c 					cairo-dock-task.h
	cairo-dock-config.c 				cairo-dock-config.h 
	texture-gradation.h
	texture-blur.h
)


########### compilation ###############

# Make sure the compiler can find include files from the libraries.
include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${XEXTEND_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

# Make sure the linker can find the libraries.
link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS}
	${XEXTEND_LIBRARY_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

# Define the library
add_library ("gldi" SHARED ${core_lib_SRCS})
STRING (REGEX REPLACE "\\..*" "" SOVERSION "${VERSION}")
set_target_properties ("gldi" PROPERTIES
	# create *nix style library versions + symbolic links
	VERSION ${VERSION}
	SOVERSION ${SOVERSION}
	# allow creating static and shared libs without conflicts
	#CLEAN_DIRECT_OUTPUT 1
	# avoid conflicts between library and binary target names
	#OUTPUT_NAME ${PROJECT_NAME}
)

# Link the result to the librairies.
target_link_libraries("gldi"
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES}
	${XEXTEND_LIBRARIES}
	${LIBCRYPT_LIBS}
	icon-factory
	implementations
	dl)


configure_file (${CMAKE_CURRENT_SOURCE_DIR}/gldi.pc.in ${CMAKE_CURRENT_BINARY_DIR}/gldi.pc)
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/gldi.pc DESTINATION ${libdir}/pkgconfig)
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so DESTINATION ${libdir})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so.${VERSION} DESTINATION ${libdir})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so.${SOVERSION} DESTINATION ${libdir})

########### install files ###############

install(FILES cairo-dock.h DESTINATION ${includedir}/cairo-dock)
install(FILES
	cairo-dock-struct.h 			cairo-dock-global-variables.h
	gldi-config.h
	cairo-dock-core.h			cairo-dock-manager.h
	cairo-dock-object.h
	cairo-dock-icon-factory.h		cairo-dock-icon-manager.h
	cairo-dock-icon-facility.h
	cairo-dock-applications-manager.h 	cairo-dock-launcher-manager.h
	cairo-dock-separator-manager.h 		cairo-dock-applet-manager.h
	cairo-dock-backends-manager.h		cairo-dock-notifications.h
	
	cairo-dock-packages.h
	cairo-dock-data-renderer.h
	cairo-dock-data-renderer-manager.h
	cairo-dock-dock-manager.h		
	cairo-dock-desklet-manager.h
	cairo-dock-dialog-manager.h
	cairo-dock-indicator-manager.h
	cairo-dock-themes-manager.h
	cairo-dock-gui-manager.h
	cairo-dock-file-manager.h
	cairo-dock-X-manager.h
	cairo-dock-class-manager.h
	cairo-dock-opengl.h
	cairo-dock-image-buffer.h
	cairo-dock-config.h
	cairo-dock-module-factory.h
	cairo-dock-module-manager.h
	cairo-dock-container.h
	cairo-dock-dock-factory.h			cairo-dock-callbacks.h
	cairo-dock-desklet-factory.h
	cairo-dock-dialog-factory.h
	cairo-dock-flying-container.h
	
	cairo-dock-applet-multi-instance.h 	cairo-dock-applet-single-instance.h
	cairo-dock-applet-canvas.h			cairo-dock-applet-facility.h
	
	cairo-dock-draw.h					cairo-dock-draw-opengl.h
	cairo-dock-opengl-path.h 			cairo-dock-opengl-font.h 
	cairo-dock-particle-system.h		cairo-dock-overlay.h
	cairo-dock-X-utilities.h			cairo-dock-dbus.h
	cairo-dock-keyfile-utilities.h		cairo-dock-surface-factory.h
	cairo-dock-log.h					cairo-dock-keybinder.h
	cairo-dock-application-facility.h	cairo-dock-dock-facility.h
	cairo-dock-task.h
	cairo-dock-animations.h
	cairo-dock-gui-factory.h
	
	DESTINATION ${includedir}/cairo-dock/gldit)

if (NOT "${enable_gtk_grip}" STREQUAL "")  # actually it's more "disable-gtk-grip" ...
	add_definitions (-DENABLE_GTK_GRIP=1)
endif()

=== src/implementations/CMakeLists.txt ===

SET(impl_SRCS
	cairo-dock-gauge.c               cairo-dock-gauge.h
	cairo-dock-graph.c               cairo-dock-graph.h
	cairo-dock-progressbar.c         cairo-dock-progressbar.h
	cairo-dock-hiding-effect.c       cairo-dock-hiding-effect.h
	cairo-dock-icon-container.c      cairo-dock-icon-container.h
	cairo-dock-default-view.c        cairo-dock-default-view.h
	cairo-dock-compiz-integration.c  cairo-dock-compiz-integration.h
	cairo-dock-kwin-integration.c    cairo-dock-kwin-integration.h
)

add_library(implementations STATIC ${impl_SRCS})
add_definitions (-fPIC)
add_definitions (-DSHARE_DATA_DIR="${pkgdatadir}")

link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS})

include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/icon-factory
	${CMAKE_SOURCE_DIR}/src/implementations)

########### install files ###############

install (FILES
	cairo-dock-gauge.h
	cairo-dock-graph.h
	cairo-dock-progressbar.h
	DESTINATION ${includedir}/cairo-dock/implementations)  # thoses are needed to expose the attributes of the data-renderers to the plug-ins.

=== data/themes/default-theme/plug-ins/switcher/CMakeLists.txt ===

########### install files ###############

install(FILES  switcher.conf DESTINATION ${pkgdatadir}/themes/Default-Single/plug-ins/switcher )

=== debian/changelog ===
cairo-dock (3.0.99.beta1.1~20120827~bzr1193-0ubuntu2) quantal; urgency=low

  * Added bzr_screens_with_null_dimensions.patch from upstream:
   - Prevent screens with null dimensions: the dock can be invisible if the
     'multi-monitors' option is enabled and a wrong screen is chosen.
   - Try to get dimensions from all screens with XRandr and also with Xinerama
     if there is a problem.

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Tue, 28 Aug 2012 11:46:13 +0200

cairo-dock (3.0.99.beta1.1~20120827~bzr1193-0ubuntu1) quantal; urgency=low

  * New upstream snapshot.
  * Upstream ChangeLog (detailed changes):
   - Task: the thread clean itself to avoid crash
      + fixed a typo with the check of bDiscard
      + cancel: checked if pThread has not been freeed before talking with it
      + converted g_print to cd_debug
      + Cancel the next iteration if 'iPeriod == 0'
   - Added a workaround for Metacity not handling the _NET_WM_OPACITY
      correctly
   - Man: Added the new -W (--metacity-workaround) option
   - XRandr: Use it by default instead of Xinerama which is deprecated
      according to its website
   - XRandr: Checked if 1.1 version is available for basic functions
      (e.g. to change the resolution) and 1.3 version (to replace Xinerama)
   - Xrandr: Added cairo_dock_xrandr_is_available (needed to avoid a crash
      in ShowDesktop applet)
   - Module Mgr: removed GModule dependence (which is no longer used since
      version 2.4)
      + stopped the compilation if 'dl' or 'm' libraries or 'dlfcn.h'
       or 'math.h' are not found
      + linked gldi to 'dl'
   - Progress bar: Cairo Backend: no longer drawn the bar if the value is 0
      (was drawn only on the Cairo backend)
   - Fixed a crash if we launch the dock with '-l debug' and if a module is
      not loaded (e.g. 'integration' modules)
   - include: <librsvg/rsvg-cairo.h> can no longer be included directly
      since LibRSVG 2.36.2
   - Class manager: handle custom .desktop files located in
      ~/.local/share/applications
   - Dialogs: fixed a small offset in the position of a dialog above its
      icon when the dock is hidden
   - Class Mgr: translations of QuickList menus are generally available in
      their Gettext domain (this info is available in the .desktop file)
   - Themes: updated themes folder, defined it in CMakeList.txt
   - Taskbar: fixed a bug that inserted an extra separator when grouping
      applis togather in a sub-dock
   - Menu: moved all window management entries to a submenu
  * debian/control:
   - Bump Cairo-Dock Plug-ins versions

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Mon, 27 Aug 2012 15:17:48 +0200

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DH_ALWAYS_EXCLUDE=CVS:.bzr

DEB_CMAKE_EXTRA_FLAGS += -Denable_gtk_grip=yes \
	-Denable-desktop-manager=yes \
	-DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_INSTALL_CHANGELOGS_ALL := ChangeLog

get-orig-source:
	dh_testdir
	uscan --force-download --verbose --repack

## cairo-dock 3.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,9 +11,9 @@
 ########### project ###############
 
 project ("cairo-dock")
-set (VERSION "3.0.99.beta1")
+set (VERSION "3.1.0")
 
-add_definitions (-std=c99 -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes) # removed for stable versions: -Wstrict-prototypes #-Wunreachable-code -Wno-unused-parameter -Wall 
+add_definitions (-std=c99 -Wall -Wextra) # -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes -Wreturn-type -Wparentheses -Warray-bounds) # removed for stable versions: -Wstrict-prototypes #-Wunreachable-code -Wno-unused-parameter -Wall 
 if (NOT ${CMAKE_BUILD_TYPE})
 	add_definitions (-O3)
 endif()
@@ -58,7 +58,7 @@
 set (pkgdatadir "${datadir}/${CMAKE_PROJECT_NAME}")  # (...)/cairo-dock
 set (mandir "${prefix}/${CMAKE_INSTALL_MANDIR}")  # (...)/man
 
-set (VERSION_HELP "0.9.992") # needed to parse Help.conf.in
+set (VERSION_HELP "0.9.993") # needed to parse Help.conf.in
 
 if( CMAKE_SIZEOF_VOID_P EQUAL 8 AND "${FORCE_LIB64}" STREQUAL "yes")  # 64bits and force install in lib64
 	set (libdir "${prefix}/lib64")

=== debian/changelog ===
cairo-dock (3.1.0-0ubuntu2) quantal; urgency=low

  * debian/control:
   - Cairo-Dock plug-ins dependencies: Removed '-0ubuntu1' to allow other
     distros and backports to work smoother (Thanks to Laney!) (LP: #1064130)

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Tue, 09 Oct 2012 23:36:25 +0200

cairo-dock (3.1.0-0ubuntu1) quantal; urgency=low

  * New upstream release. (LP: #1064130)
   - Even if there are a lot of changes, this is a 'bug-fix' version.
     Changes are big mainly because the translations have been updated and
     a lot of GCC warnings (from -Wall and -Wextra) have been fixed.
  * Upstream ChangeLog (detailed changes since the last version):
   - Only disable drag'n'drop onto the dock when the dock is completely
      locked, not when the icons position is locked.
   - Prevented quicklists for an icon
      (e.g. used by musicPlayer applet to remove double menu entries)
   - Menu: renamed this title: 'Below *other* windows'
     + fixed a typo (bIsMaximized was checked a bit too late)
   - Man: 'A' ('ask-backend') option was missing and 'i' (indirect) is
      no longer supported + for 'colors', used 'F' instead of 'A' which
      is already used by 'ask-backend'
   - When a label is updated, update the drawing accordingly
   - Dialogs: fixed a crash if the dialog was forced above (GTK3)
   - Advanced GUI: fixed a bug that prevented to edit a 2nd instance of
      an applet
      + renamed 'cairo-dock-gui-main.[ch]' to 'cairo-dock-gui-advanced.[ch]'
   - Don't close the dock if no plug-ins are found, just display the message
   - Menu on appli: put the window actions into a single menu-item, which
      avoid having a crowded menu or another sub-menu
   - Default view: use all the screen space to avoid the jitter of the dock
      when it is resized (although this is mainly a problem in the Window
      Managers, unfortunately very few handle the resizing correctly)
   - Locked dock: prevent any modification when the dock is locked
   - Advanced GUI: fixed a small bug when reloading an applet
   - Application manager: handle the case where there is no dock
      (e.g. for cairo-desklet)
   - when starting in maintenance mode, force the use of the advanced
      configuration (easier to fix problem)
   - Compilation: fixed a lot of warnings during the compilation
      (mostly 'unused-variable' and 'unused-parameters' by using
       G_GNUC_UNUSED) when using -Wall and -Wextra
   - GTK3.4: used GtkGrid instead of GtkTable (now deprecated)
   - Labels in vertical dock:
    + fixed the calculation with a helper
    + terminate with a gradation if the label is too large to be fully drawn
    + fixed a small offset in the position of the X icon geometry
   - Indicators: icons was not visible with the Cairo backend if we wanted to
      have an image as indicator of the active window and if we don't give
      any image
   - Fixed a bug in cairo_dock_create_surface_from_pattern
      (when using a pattern as the background image)
   - Themes: Added write rights in the new theme folder
      (if the user has just changed its current theme)
   - OpenGL backend: fixed a small bug in the drawing of always visible icons
   - Fixed a crash when re-inserting an applet into a dock
   - GUI: fixed 2 bugs in the module widget
   - Taskbar: when placing appli icons after launchers, don't count
      separators as launchers
   - When loading an image based on a pattern, constrain the image height,
      so that it only repeats on its width
   - Taskbar: added back the use of _NET_WM_STATE_DEMANDS_ATTENTION
      (this might be used by Skype and therefore solve the bug LP: #1013635)
   - Menu: Window Actions: drawn: Min - Max - Close instead of
      Max - Min - Close + drawn Min and Max only if the window is not hidden
   - Code cleaning: removed a few useless g_print (or used cd_debug instead)
   - Menu: Custom icon: only display images on the file chooser
   - Menu: Custom Icon: do not display the menu entry if bLockAll is defined
      (if the action is useless) + do not stop the action if bLockIcons
   - Widget Items: the main GtkWindow is needed to build other widgets
   - po: imported translations from Launchpad and Added Lithuanian language
   - Options: AskBackend: show the backend even if we force the use of the
      OpenGL backend
   - Help: Help menu entry: this menu entry no longer worked: used
      cairo_dock_show_items_gui like the Edit menu entry
   - Menu: Help menu entry: if we use the simple mode, switch to the advanced
      mode because the help settings are only available there
   - Some cleaning
  * debian/patches/bzr_screens_with_null_dimensions.patch:
   - Removed (now in upstream)
  * Added bzr_translate_titles_of_categories_and_readme from upstream:
   - Translate the titles of all main categories and views' description
  * debian/control:
   - Bumpped Cairo-Dock Plug-ins versions

 -- Matthieu Baerts (matttbe) <matttbe@ubuntu.com>  Tue, 09 Oct 2012 02:53:48 +0200

=== debian/control ===
Source: cairo-dock
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthieu Baerts (matttbe) <matttbe@ubuntu.com>, Julien Lavergne <julien.lavergne@gmail.com>, Fabrice Rey <fabounet@glx-dock.org>
Build-Depends: cdbs,
               cmake,
               debhelper (>= 8.1.3),
               libcairo2-dev,
               libcurl4-gnutls-dev,
               libdbus-glib-1-dev,
               libgl1-mesa-dev | libgl-dev,
               libglib2.0-dev,
               libglu1-mesa-dev | libglu-dev,
               libgtk-3-dev,
               libpango1.0-dev,
               librsvg2-dev,
               libxcomposite-dev,
               libxinerama-dev,
               libxml2-dev,
               libxrender-dev,
               libxtst-dev
Standards-Version: 3.9.3
Homepage: http://www.glx-dock.org/

Package: cairo-dock
Section: graphics
Architecture: all
Conflicts: cairo-dock (<= 2.0.8.0)
Depends: cairo-dock-core (>= ${source:Version}),
         cairo-dock-plug-ins (>= 3.1.0),
         cairo-dock-plug-ins-dbus-interface-python (>= 3.1.0),
         cairo-dock-plug-ins-integration (>= 3.1.0),
         ${misc:Depends}
Description: Light and eye-candy dock to launch your programs (metapackage)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This metapackage provides the components necessary for running Cairo-Dock. It
 provides the Cairo-Dock core, a set of standard plugins and the files necessary
 to integrate Cairo-Dock with your desktop environment.

Package: cairo-dock-core
Section: graphics
Architecture: any
Conflicts: cairo-dock (<= 2.0.8.0)
Replaces: cairo-dock (<= 2.0.8.0)
Depends: cairo-dock-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: cairo-dock,
            cairo-dock-plug-ins,
            compiz-plugins | e17 | kde-window-manager | openbox | xfwm4
Suggests: compiz-plugins, gnome-session
Description: Light and eye-candy dock to launch your programs (core package)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package is the core of Cairo-Dock project.

Package: libgldi-dev
Section: libdevel
Architecture: any
Depends: libcairo2-dev,
         libcurl4-gnutls-dev,
         libdbus-glib-1-dev,
         libgl1-mesa-dev | libgl-dev,
         libgldi3 (= ${binary:Version}),
         libglib2.0-dev,
         libglu1-mesa-dev | libglu-dev,
         libgtk-3-dev,
         libpango1.0-dev,
         librsvg2-dev,
         libxcomposite-dev,
         libxinerama-dev,
         libxml2-dev,
         libxrender-dev,
         libxtst-dev,
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: cairo-dock
Multi-Arch: same
Description: Light and eye-candy dock to launch your programs (dev package)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package provides the include files and static library for cairo-dock
 functions.

Package: cairo-dock-data
Section: graphics
Architecture: all
Conflicts: cairo-dock (<= 2.0.8.0)
Replaces: cairo-dock (<= 2.0.8.0)
Depends: ${misc:Depends}
Description: Light and eye-candy dock to launch your programs (common files)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package contains default icons and themes for Cairo-Dock.

Package: libgldi3
Section: graphics
Architecture: any
Conflicts: cairo-dock (<= 2.0.8.0)
Replaces: cairo-dock (<= 2.0.8.0), cairo-dock-core (<< 3.0.0)
Breaks: cairo-dock-core (<< 3.0.0)
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: cairo-dock-data (>= ${source:Version})
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Light and eye-candy dock to launch your programs (lib package)
 Cairo-Dock is a pretty, light and convenient interface to your desktop,
  able to replace advantageously your system panel!
 It features multi-docks, taskbar, launchers and a lot of useful applets.
 Applets can be detached from the dock to act as desktop widgets.
 Numerous ready-to-use themes are downloadable in 1 click, and can be easily
  customized at your convenience.
 It can use hardware acceleration to be very fast and low on CPU.
 .
 Some screenshots are available : http://pics.glx-dock.org
 Development site: https://launchpad.net/cairo-dock
 .
 This package contains the library created and used by the Cairo-Dock project.

## cairo-dock 3.1.1

=== debian/changelog ===
cairo-dock (3.1.1-2) unstable; urgency=low

  * Update version of cairo-dock-plug-ins. (Closes: #692012)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 24 Nov 2012 11:25:31 +0900

cairo-dock (3.1.1-1) unstable; urgency=low

  * Imported Upstream version 3.1.1

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 17 Nov 2012 17:19:10 +0900

cairo-dock (3.1.0-1) unstable; urgency=low

  [ Youhei SASAKI ]
  * Imported Upstream version 3.1.0
    - Fix GCC-4.7 optimization (Closes: #676841)
  * Update debian/cairo-dock-core.install
    - Remove usr/bin/cairo-dock-package-theme 
  * Add unapply-patches for unapply patches after build
  * Add patch: Fix typo
  * Add patch: Remove Encoding from desktop files
  * Update debian/changelog
  * Fix debian/control: remove duplicate fileds

 -- Youhei SASAKI <uwabami@gfd-dennou.org>  Sun, 14 Oct 2012 04:05:07 +0900

cairo-dock (3.0.2-1) experimental; urgency=low

  * Imported Upstream version 3.0.2.
  * Fix syntax-error-in-dep5-copyright.
  * Update debian/control.
    Add dpkg-dev (>= 1.16.1~) to Build-Depends
  * Update debian/rules.
    Enable hardening
  * Remove 0001-Fix-GLIB-Single-Include-issue-Closes-665514.patch
    And patches directory.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Fri, 27 Jul 2012 09:27:53 +0900

=== debian/control ===
Source: cairo-dock
Section: x11
Priority: extra
Maintainer: Debian Cairo-dock Maintainers <pkg-cairo-dock-devel@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>,
 Youhei SASAKI <uwabami@gfd-dennou.org>
Build-Depends: cdbs, debhelper (>= 7), dpkg-dev (>= 1.16.1~),
		autotools-dev, intltool, pkg-config,
		libcairo-dev, libdbus-1-dev, librsvg2-dev, libxml2-dev,
		libxrender-dev, libxtst-dev, libgtkglext1-dev, libcurl4-gnutls-dev,
		libdbus-glib-1-dev, libgtk-3-dev, quilt, cmake (>= 2.8.0)
Standards-Version: 3.9.3
Homepage: http://www.glx-dock.org/
Vcs-Git: git://git.debian.org/pkg-cairo-dock/cairo-dock.git
Vcs-Browser: http://git.debian.org/git/pkg-cairo-dock/cairo-dock.git

Package: cairo-dock
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, cairo-dock-core (= ${binary:Version}), cairo-dock-plug-ins (>= 3.1.1)
Conflicts: cairo-dock (<= 2.1.3.5-2)
Description: Metapackage for cairo-dock
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This is metapackage that provides the components necessary for running
 Cairo-dock. This installs a cairo-dock-core application and cairo-dock-plugins
 package easily.
 .
 And Cairo-dock installs cairo-dock-core and plugins and makes sense as
 Cairo-dock.

Package: cairo-dock-core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: cairo-dock (<= 2.1.3.5-2)
Replaces: cairo-dock (<= 2.1.3.5-2)
Provides: cairo-dock
Suggests: xcompmgr, empathy, f-spot, gcalctool, gimp, inkscape
Recommends: cairo-dock-plugins (>= 2.1.3.10), curl
Description: Light eye-candy fully themable animated dock for Linux desktop
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This package provides Cairo-dock-core application.

Package: cairo-dock-dev
Section: devel
Architecture: any
Depends: cairo-dock-core (= ${binary:Version}), ${misc:Depends}
Description: Cairo-dock develpment file
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This package provides Cairo-dock development file.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

DEB_CONFIGURE_USER_FLAGS= --enable-xextend
DEB_COMPRESS_EXCLUDE := cairo-dock-package-theme
clean::
	rm -f src/config.h
	rm -f src/gldit/gldi-config.h
